/*
 * A front-end to the mread/mwrite commands.
 *
 * Emmet P. Gray			US Army, HQ III Corps & Fort Hood
 * ...!uunet!uiucuxc!fthood!egray	Attn: AFZF-DE-ENV
 * fthood!egray@uxc.cso.uiuc.edu	Directorate of Engineering & Housing
 * 					Environmental Management Office
 * 					Fort Hood, TX 76544-5057
 * Version 2.0.0	 8 Sep 90
 *  patch #1		12 Oct 90
 *  patch #2		21 Nov 90
 *  patch #3		28 Nov 90
 */

#include <stdio.h>

#define NONE	0
#define MREAD	1
#define MWRITE	2

main(argc, argv)
int argc;
char *argv[];
{
	extern int optind;
	extern char *optarg;
	int i, oops, msdos_args, unix_args, destination;
	char **nargv, *strcpy(), *malloc();
	void exit();
					/* get command line options */
	msdos_args = 0;
	unix_args = 0;
	oops = 0;
	while ((i = getopt(argc, argv, "tnvm")) != EOF) {
		switch (i) {
			case 't':
			case 'n':
			case 'v':
			case 'm':
				break;
			default:
				oops = 1;
				break;
		}
	}

	if (oops || (argc - optind) < 2) {
		fprintf(stderr, "Usage: %s [-tnvm] msdosfile unixfile\n", argv[0]);
		fprintf(stderr, "       %s [-tnvm] msdosfile [msdosfiles...] unixdirectory\n", argv[0]);
		fprintf(stderr, "       %s [-tnm] unixfile msdosfile\n", argv[0]);
		fprintf(stderr, "       %s [-tnm] unixfile [unixfiles...] msdosdirectory\n", argv[0]);
		exit(1);
	}
					/* what is the destination drive? */
	destination = NONE;
					/* first file */
	if (argv[optind][1] == ':')
		destination = MREAD;
					/* last file */
	if (destination == NONE && argv[argc - 1][1] == ':')
		destination = MWRITE;

	if (destination == NONE) {
		fprintf(stderr, "%s: no drive letter designation specified\n", argv[0]);
		exit(1);
	}
					/* count the arguments */
	for (i = optind; i < argc; i++) {
		if (argv[i][1] == ':')
			msdos_args++;
		else
			unix_args++;
	}
					/* sanity checking */
	if (!msdos_args || !unix_args) {
		fprintf(stderr, "%s: unresolved destination\n", argv[0]);
		exit(1);
	}
	if ((destination == MWRITE && msdos_args > 1) || (destination == MREAD && unix_args > 1)) {
		fprintf(stderr, "%s: duplicate destination files\n", argv[0]);
		exit(1);
	}

	/*
	 * Copy the *argv[] array in case your Unix doesn't end the array
	 * with a null when it passes it to main()
	 */
	nargv = (char **) malloc((unsigned int) (argc + 1) * sizeof(*argv));
	nargv[argc] = NULL;
	for (i = 1; i < argc; i++)
		nargv[i] = argv[i];

	if (destination == MWRITE) {
		nargv[0] = "mwrite";
		execvp("mwrite", nargv);
	}
	else {
		nargv[0] = "mread";
		execvp("mread", nargv);
	}
}
